{ -*- buffer-read-only: t -*-

  Copyright 2015-2024 Michalis Kamburelis.

  This file is part of "Castle Game Engine".

  "Castle Game Engine" is free software; see the file COPYING.txt,
  included in this distribution, for details about the copyright.

  "Castle Game Engine" is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

  ----------------------------------------------------------------------------
}

{ Automatically generated node properties.

  Do not edit this file manually!
  To add new properties:
  - add them to the text files in tools/internal/x3d-nodes-to-pascal/nodes-specification/ ,
  - and regenerate include files by running x3d-nodes-to-pascal }

{$ifdef read_interface}

  public
    procedure CreateNode; override;
    class function ClassX3DType: string; override;

    strict private FFdLineSegments: TMFVec2f;
    { Internal wrapper for property @link(LineSegments). This wrapper API may change, we advise to access simpler @link(LineSegments) instead. }
    public property FdLineSegments: TMFVec2f read FFdLineSegments;
    {  }
    procedure SetLineSegments(const Value: array of TVector2); overload;
    {  }
    procedure SetLineSegments(const Value: TVector2List); overload;

{$endif read_interface}

{$ifdef read_implementation}

{ TPolyline2DNode ----------------------------------------------- }

procedure TPolyline2DNode.SetLineSegments(const Value: array of TVector2);
begin
  FdLineSegments.Send(Value);
end;

procedure TPolyline2DNode.SetLineSegments(const Value: TVector2List);
begin
  FdLineSegments.Send(Value);
end;

class function TPolyline2DNode.ClassX3DType: String;
begin
  Result := 'Polyline2D';
end;

procedure TPolyline2DNode.CreateNode;
begin
  inherited;

  FFdLineSegments := TMFVec2f.Create(Self, False, 'lineSegments', []);
   FdLineSegments.ChangeAlways := chVisibleNonGeometry;
  AddField(FFdLineSegments);
end;

{$endif read_implementation}
